; ͻ
;   FILE : ACAD.LSP                                                         
; Ķ
;   FUNC : BASIC SETUP (COMBINATION OF PROGRAMS)                            
;   FROM : GARY ANNABLE                                                     
;   DATE :  7/18/86 - ADDED TITLE                                           
;        : 10/17/86 - ADDED LOAD COMMAND                                    
;        :  6/26/87 - ADDED Z COMMAND                                       
;        :  3/14/88 - ADDED PCOM FUNCTION                                   
;        :  1/24/90 - ADDED GETATT & CHGATT FUNCTIONS FOR BLOCK "VAR"       
; ͼ
;
;
; Standard Error Message Function
;
(vmon)
(print "Loading acad.lsp .")
(defun *error* (MSG)
 (princ "error: ")
 (princ MSG)
 (terpri)
)
;
; New AutoCad Command Definitions
;
(princ " .")
(defun C:0 ()
 (setq FL (getstring "\n File to Load : "))
 (load FL)
)
(princ " .")
(defun C:B()(menucmd "S=X")(menucmd "S=BASE")(command "BASE")(princ))
(defun C:C()(menucmd "S=X")(menucmd "S=CHAMFER")(command "CHAMFER")(princ))
(defun C:D()(command "DXFIN"))
(defun C:F()(command "layer" "f" "*"))
(princ " .")
(defun C:I (/ S1 S2 S3)
 (setq S1 "D:/ACAD/BLOCKS/")
 (setq S2 (getstring "Name of Block To Insert : "))
 (setq S3 (strcat S1 S2))
 (command "INSERT" S3)
)
(princ " .")
(defun C:L()(menucmd "S=X")(menucmd "S=LIMITS")(command "LIMITS"))
(defun C:O()(command "OOPS")(princ))
(defun C:PCOM ()
 (setq e (car (entsel "Pick your command. ")))
 (setq e (entget e))
 (setq com (cdr (assoc 0 e)))
 (if (= com "TEXT") (setq com "DTEXT"))
 (if (= com "POLYLINE") (setq com "PLINE"))
 (command com)
 (prin1)
)
(princ " .")
(defun C:R ()
 (setvar "blipmode" 0)
 (setvar "cmdecho" 0)
 (setvar "expert" 4)
 (setvar "flatland" 1)
 (setvar "highlight" 1)
 (setvar "osmode" 0)
 (setvar "skpoly" 1)
 (setvar "ucsicon" 0)
 (command "regenauto" "off")
 (princ)
)
(princ " .")
(defun C:S()(command "SCRIPT"))
(defun C:SP1()(setq SP1 (getpoint "\nEnter Point Number  1 ")))
(defun C:SP2()(setq SP2 (getpoint "\nEnter Point Number  2 ")))
(defun C:SP3()(setq SP3 (getpoint "\nEnter Point Number  3 ")))
(defun C:SP4()(setq SP4 (getpoint "\nEnter Point Number  4 ")))
(defun C:UN()(menucmd "S=X")(menucmd "S=UNITS")(command "UNITS"))
(defun C:V()(menucmd "S=MAIN")(command "VIEWPORT")(princ))
;
; Miscellaneous Functions called from other programs
;
;Routine to search the block VAR and GHG a selected attribute
(princ " .")
(defun CHKLAY (LAY)
 (if (equal (tblsearch "LAYER" LAY) nil)
  (command "layer" "m" LAY "s" LAY "")
  (command "layer" "t" LAY "on" LAY "s" LAY "")
 )
(princ)
)
(defun CHGATT (ATTNUM REPLACE)
 (setq COUNT 1)
 (setq ENT (entget (entnext (ssname (ssget "x" '((2 . "VAR")))0))))
 (while (< COUNT ATTNUM)
  (setq ENT (entget (entnext (cdr (assoc -1 ENT)))))
  (setq COUNT (+ 1 COUNT))
 )
 (setq NAME (assoc 1 ENT))
 (entmod (subst (cons 1 REPLACE) NAME ENT))
 (entupd (cdr (assoc -1 ENT)))
)
(princ " .")
(defun dtr (a)(* pi (/ a 180.0)))
(defun rtd (a)(/ (* a 180.0) pi))
(defun adjusta (ANG)
 (setq ANG
  (if
   (and
    (>= ang (/ (* 3.0 pi) 2.0))
    (<= ang (* 2.0 pi))
   )
   (- ang (* 2.0 pi)) ang
  )
 )
)
(princ " .")
(defun get (K L)
 (cond
  ((listp K)(mapcar '(lambda (x)(cdr (assoc X L))) K))(T (cdr (assoc K L)))
 )
)
;Routine to search the block VAR and Get a selected attribute
(princ " .")
(defun GETATT (ATTNUM)
 (setq AENT (entget (ssname (ssget "x" '((2 . "VAR")))0)))
 (setq ENT (cdr (assoc -1 AENT)))
 (setq COUNT 0)
 (while (< COUNT ATTNUM)
  (setq ENT (entnext ENT))
  (setq COUNT (1+ COUNT))
 )
 (cdr (assoc 1 (entget ENT)))
)
(defun getsize ()
 (setq SIZE (getreal "\nSelect or enter size: "))
 (menucmd "S=")
)
(princ " .")
(defun vertex (/ LN1 LN2 P1 P2 P3 P4)
 (setq LN1 (entget (car (entsel "\nSelect first line: "))))
 (setq LN2 (entget (car (entsel "\nSelect second line: "))))
 (if (and LN1 LN2)
  (progn
   (setq P1 (cdr (assoc 10 LN1)))
   (setq P2 (cdr (assoc 11 LN1)))
   (setq P3 (cdr (assoc 10 LN2)))
   (setq P4 (cdr (assoc 11 LN2)))
   (setq XPT (inters P1 P2 P3 P4 nil))
  )
 )
)
(princ " .")
(defun xline ( / FR TO IP XL SS I ENT)
 (setvar "cmdecho" 0)
 (cond
  ((and (setq FR (getpoint "\nCrossing line from point: "))
    (setq TO (getpoint fr "To point: "))
    (setq XL (list FR TO T))
    (setq SS (ssget "C" FR TO))
    (setq I -1))
    (while
     (setq ENT (ssname SS (setq I (1+ I))))
     (cond
      ((and
       (eq "LINE" (get 0 (setq ENT (entget ENT))))
       (setq IP (apply 'inters (append (get '(10 11) ENT) XL)))
      )
      (command IP)
     )
    )
   )
  )
 )
 (prin1)
)
;
; AUTOMATIC Start-up Functions and Commands
;
(princ " .")
(defun s::startup ()
 (setvar "blipmode" 0)
 (setvar "cmdecho" 0)
 (setvar "coords" 2)
 (setvar "expert" 4)
 (setvar "flatland" 1)
 (setvar "highlight" 1)
 (setvar "osmode" 0)
 (setvar "pdmode" 32)
 (setvar "skpoly" 1)
 (setvar "ucsicon" 0)
 (command "regenauto" "off")
 (setq STIME (getvar "tdindwg"))
 (if (equal (tblsearch "BLOCK" "VAR") nil)
  (command "insert" "var" "0,0" "1" "" ""
 "" "" "" "" "" "" "" "" "" "" "" "" "" "" "" "" "" "" "" "" "" "" "" "")
 )
 (setq AENT (entget (ssname (ssget "x" '((2 . "VAR")))0)))
 (setq ENT (cdr (assoc -1 AENT)))
 (setq ENT (entnext ENT))(setq SCAL (cdr (assoc 1 (entget ENT))))
 (setq ENT (entnext ENT))(setq SCF (cdr (assoc 1 (entget ENT))))
 (setq ENT (entnext ENT))(setq TH (cdr (assoc 1 (entget ENT))))
 (setq ENT (entnext ENT))(setq LDSC (cdr (assoc 1 (entget ENT))))
 (setq ENT (entnext ENT))(setq W1 (cdr (assoc 1 (entget ENT))))
 (setq ENT (entnext ENT))(setq W2 (cdr (assoc 1 (entget ENT))))
 (setq ENT (entnext ENT))(setq W3 (cdr (assoc 1 (entget ENT))))
 (setq ENT (entnext ENT))(setq W4 (cdr (assoc 1 (entget ENT))))
 (setq ENT (entnext ENT))(setq DLAY (cdr (assoc 1 (entget ENT))))
 (setq ENT (entnext ENT))(setq LCOR (cdr (assoc 1 (entget ENT))))
 (setq ENT (entnext ENT))(setq DNAM (cdr (assoc 1 (entget ENT))))
 (setq ENT (entnext ENT))(setq ODAT (cdr (assoc 1 (entget ENT))))
 (setq ENT (entnext ENT))(setq ODOP (cdr (assoc 1 (entget ENT))))
 (setq ENT (entnext ENT))(setq RDAT (cdr (assoc 1 (entget ENT))))
 (setq LDAT RDAT)
 (setq ENT (entnext ENT))(setq RDOP (cdr (assoc 1 (entget ENT))))
 (setq LDOP RDOP)
 (setq ENT (entnext ENT))(setq CREV (cdr (assoc 1 (entget ENT))))
 (setq ENT (entnext ENT))(setq RO1X (cdr (assoc 1 (entget ENT))))
 (setq ENT (entnext ENT))(setq RO1Y (cdr (assoc 1 (entget ENT))))
 (setq ENT (entnext ENT))(setq RO2X (cdr (assoc 1 (entget ENT))))
 (setq ENT (entnext ENT))(setq RO2Y (cdr (assoc 1 (entget ENT))))
 (setq cd (rtos (getvar "cdate") 2 6))
 (setq cdate (strcat (substr cd 5 2) "/" (substr cd 7 2) "/" (substr cd 3 2)))
 (setq DNAME (getvar "dwgname"))
 (if (= DNAM "ACAD")
  (CHGATT 11 DNAME)
 )
 (if (= ODAT "0")
  (CHGATT 12 CDATE)
 )
 (CHGATT 14 CDATE)
 (if (/= RDOP ODOP)
  (CHGATT 15 RDOP)
 )
 (if (= TEXTSZ nil) (setq TEXTSZ 1))
 (command "regenauto" "off")
 (setq LI (getvar "limmax"))
 (setq FPLI (car LI))
 (if (= FPLI 12.0)(princ "\n\n******   LIMITS HAVE NOT BEEN SET !   ***** ")
 )
 (command "UNDEFINE" "END")
 (command "UNDEFINE" "SAVE")
 (princ)
)

; END.LSP - MODIFIED FROM LOG.LSP
; ORIGINAL FILES ARE INCLUDED
(defun C:END ()
 (setq TEMP (getstring 1 "\nEnter Revision         : "))
 (CHGATT 16 TEMP)
 (setq DNAME "       ")
 (setq DNAME (substr (getvar "DWGNAME") 1 8))
 (setq ETIME (* (- (getvar "TDINDWG") stime) 24.0))
 (setq MONTH (substr (rtos (getvar "CDATE") 2 0) 5 2))
 (setq DAY (substr (rtos (getvar "CDATE") 2 0) 7 2))
 (setq YEAR (substr (rtos (getvar "CDATE") 2 0) 3 2))
 (setq HRS (itoa (fix etime)))
 (setq MIN (itoa (fix (setq mins (* (- etime (fix etime)) 60.0)))))
 (setq SEC (itoa (fix (* (- mins (fix mins)) 60.0))))
 (setq DIARY (open "diary" "a"))
 (setq PARTA (strcat "User:"LDOP" -- Date: "MONTH "/" DAY "/" YEAR))
 (setq PARTB (strcat "  Dwg = " DNAME"  Editing time: " HRS " hrs., " MIN))
 (setq PARTC (strcat " min., " SEC " sec."))
 (setq PART (strcat PARTA PARTB PARTC))
 (write-line PART diary)
 (write-line (strcat "Revision : " TEMP) diary)
 (write-line "-------------------------------------------------------------
-----------------------------------------------------" diary)
 (close diary)
 (command ".end")
)

; SAVE.LSP - MODIFIED FROM LOG.LSP
; ORIGINAL FILES ARE INCLUDED
(defun C:SAVE ()
 (setq TEMP (getstring 1 "\nEnter Revision         : "))
 (CHGATT 16 TEMP)
 (setq DNAME "       ")
 (setq DNAME (substr (getvar "DWGNAME") 1 8))
 (setq ETIME (* (- (getvar "TDINDWG") stime) 24.0))
 (setq MONTH (substr (rtos (getvar "CDATE") 2 0) 5 2))
 (setq DAY (substr (rtos (getvar "CDATE") 2 0) 7 2))
 (setq YEAR (substr (rtos (getvar "CDATE") 2 0) 3 2))
 (setq HRS (itoa (fix etime)))
 (setq MIN (itoa (fix (setq mins (* (- etime (fix etime)) 60.0)))))
 (setq SEC (itoa (fix (* (- mins (fix mins)) 60.0))))
 (setq DIARY (open "diary" "a"))
 (setq PARTA (strcat "User:"LDOP" -- Date: "MONTH "/" DAY "/" YEAR))
 (setq PARTB (strcat "  Dwg = " DNAME"  Editing time: " HRS " hrs., " MIN))
 (setq PARTC (strcat " min., " SEC " sec."))
 (setq PART (strcat PARTA PARTB PARTC))
 (write-line PART diary)
 (write-line (strcat "Revision : " TEMP) diary)
 (write-line "-------------------------------------------------------------
-----------------------------------------------------" diary)
 (close diary)
 (command ".save")
 (princ)
)
