Definitions file for SURFMODL file -- DEFINES.INC
To compile this program, modify the defines below to match your
system, then comment these uncommented lines so that the file will
compile.  (For most users, the defaults already in this file are
suitable.)

{Definitions for SurfModl program }

{Status  Variable      Action when defined                       }

{$UNDEF  DEBUG   }   { used if debugging information is required           }
{$UNDEF  MEMRPT  }   { Gives a memory usage report                         }
{$DEFINE  BIGMEM  }   { Used for large memory model                         }
{$DEFINE  NOSHADOW}   { Deletes the code for processing shadows             }
{$UNDEF  ANSICRT }   { Define if ANSI.SYS used instead of IBM specific CRT }
{$DEFINE  USE8087 }   { Define if you wish to use the 8087 chip             }

{ Defines for linking Borland's .BGI files into your .EXE file   }
{$UNDEF  LINKATT }   { Links AT&T graphics driver into memory    }
{$UNDEF  LINKCGA }   { Links CGA graphics driver into memory     }
{$UNDEF  LINKEGAVGA} { Links EGAVGA graphics driver into memory  }
{$UNDEF  LINKPC3270} { Links PC3270 graphics driver into memory  }
{$UNDEF  LINKHERC}   { Links HERCULES graphics driver into memory}
{$UNDEF  LINKVGA256} { Links VGA256 graphics driver into memory  }

{Defines for Optionally supported devices (NON .BGI routines     }
{$UNDEF  VAXMATE }   { Digital Vaxmate with 640x400x4 resolution }
{$UNDEF  USE_IFF }   { Amiga IFF file format                     }

{***********  End of User Modifyable Defines ********************}

{NOTES:                                                          }
{      The VAXMATE is included for demonstration purposes only.  }
{do not count on it being included as system "11" (see SURFGRAF) }
{in future versions.  You get better results if you use the AT&T }
{.BGI file, along with the included "EmulATT" program, which     }
{makes a VAXmate emulate the AT&T hires mode.                    }
{                                                                }
{If you have a Colour VAXmate computer, then you may wish to use }
{the DEFINE above because it (partially) supports the 640x400x4  }
{4 colour mode.                                                  }

{******************** Turbo Defined Directives ******************}
{The following directives are defined by Turbo Pascal, based on  }
{defines the programmer set above.  You should not change these  }
{defines.                                                        }

{$UNDEF EXTERNAL}  { This is defined if NON-BGI graphics are used}
{$IFDEF VAXMATE}   { External VAXMATE driver used                }
  {$DEFINE EXTERNAL}
{$ENDIF}
{$IFDEF USE_IFF}   { Support dumping graphics to IFF file        }
  {$DEFINE EXTERNAL}
{$ENDIF}
{If you create your own external driver (sanyo, hp, etc.) add a  }
{similar define to the VAXmate here.                             }

{$IFDEF DEBUG} { Set the Debugging compiler directives}
{$IFDEF BIGMEM}
  {$R-}   {Range checking off}
{$ELSE} { BIGMEM }
  {$R+}   {Range checking on}
{$ENDIF} { BIGMEM }
  {$D+}   {Debugging on}
  {$V+}   {Strict VAR checking on}
  {$L+}   {Local symbols on}
{$ELSE} { No debugging compiler directives }
  {$R-}   {Range checking off}
  {$D-}   {Debugging off}
  {$V-}   {Strict VAR checking off}
  {$L-}   {Local symbols off}
{$ENDIF}

{ Compiler directives always in effect}
{$S+}   {Stack checking on}
{$I+}   {I/O checking on}
{$F-}   {Don't force far calls}
{$B-}   {Boolean evaluation Short Circuit}
{$M 16000,0,655360 } {Stack, Low Heap, High Heap}

{$IFDEF USE8087} {directives specific to the 80x87 chip}
{$N+}   {Use numeric coprocessor}
{$ENDIF}
