;DEFVIEW
;Routine to assign a set of view windows in a spreadsheet style
;to be used with a tablet that has the View;R;N command assigned to the cell
;N = View number
; View 0 is the original window chosen by the user
;
;    Ŀ
;    1234567   my tablet looks like this only 7 rows and 7 columns
;    Ĵ
;    89     
;    Ĵ
;           
;    Ĵ
;           
;    Ĵ
;           
;    

; Routine written by Anil Gupte - Cad Conference Leader - Exec PC
; Modified by me, Wade Hammond  2-21-91


(defun C:DEFVIEW ()
     (initget 1)
     (setq p1 (getpoint "\npick one corner: "))
     (initget 1)
     (setq p2 (getcorner p1 "pick other corner: "))
     (initget 1)
     (setq rows (getint "\nNumber of rows: "))
     (initget 1)
     (setq cols (getint "\nNumber of columns: ")
           rinc (/ (- (cadr p2) (cadr p1)) rows)
           cinc (/ (- (car p2) (car p1)) cols)
           i 0 j 0 k 1
     )
     (command ".VIEW" "W"  0  p1 p2)
     (while (< j rows)
          (while (< i cols)
               (command ".VIEW" "W"  k (list (+ (car  p1) (* cinc i))
                                             (+ (cadr p1) (* rinc j)))
                                       (list (+ (car  p1) (* cinc (+ i 1)))
                                             (+ (cadr p1) (* rinc (+ j 1))))
               )
               (setq k (1+ k))
               (setq i (1+ i))
          )
          (setq j (1+ j))
          (setq i 0)
     )
     (prompt "\nDone! - View 0 is original window pick")
     (prin1)
)
