//    ELSAVIEW.DCL  Version 1.0
//
//    Copyright (C) 1992 by ELSA America, Inc.
//         
//    This file is intended for use with the product ELSAVIEW.EXP.
//    Any changes to this file not suggested and results may be 
//    unpredictable.  Only advanced users should tamper with this file.
//
//    THIS SOFTWARE IS PROVIDED "AS IS" WITHOUT EXPRESS OR IMPLIED
//    WARRANTY.  ALL IMPLIED WARRANTIES OF FITNESS FOR ANY PARTICULAR
//    PURPOSE AND OF MERCHANTABILITY ARE HEREBY DISCLAIMED.

//    This file should not be modified when used with AutoCAD.
//    Modification to the dialogue definitions can have serious adverse
//    effects on the use of the product.  

//    dcl_settings : default_dcl_settings { audit_level = 3; }

viewer : dialog {
   aspect_ratio = 0;
   label = "ELSA-View";
   :row{
      :button{
         label = "Insert";
         key   = "insert";
      }
      :button{
         label = "Open";
         key   = "open";
      }
      :button{
         label = "Zoom Extents";
         key   = "ze";
      }
      :button{
         label = "Findit...";
         key = "finder";
      }
      :button{
         label = "Sort by...";
         key = "sort";
         fixed_width = true;
      }
      :button{
         label = "About...";
         key = "about";
         fixed_width = true;
      }
   }
   :row{
      :image_button{
         color = -2;
         key = "the_image";
         width  = 51;
         height = 20;

      }
      :list_box{
         label = " Drawings  ";
         height = 18;
         width = 9;
         fixed_width = true;
         key = "the_list";
      }
      :column{
         :list_box{
            label = "Directory ";
            key = "the_dir";
            width = 11;
            height = 17;
            fixed_width = true;
         }
         :row{
            :text{
               label = "Disk";
            }
            :popup_list{
               key  = "drives";
               edit_width = 2;
               width = 2;
               fixed_width = true;
            }
         }
      }
   }
   :row{
      :text{
         label = "No Active Drawing";
         key = "the_name";
         width = 25;
      }
   }
   :row{
      :row{
         fixed_width = true;
         :text{
            label = "Date:";
            width = 5;
         }
         :text{
            label = "        ";
            key = "date";
            width = 8;
         }
         
         :text{
            label = "Time:";
            width = 5;
         }
         :text{
            label = "     ";
            key = "time";
            width = 5;
         }
         
         :text{
            label = "Size:";
            width = 5;
         }
         :text{
            label = "      ";
            key = "size";
            width = 8;
         }
      }
      :edit_box{
         label = "File:";
         key = "edname";
         fixed_width = true;
         width = 30;
      }
   }
   :row{
      :edit_box{
         label = "Notes:";
         key = "notes";
         width = 65;
         fixed_width = true;
      }
      cancel_button;
   }
}

test : dialog {
   label = "Enter Pattern";
   : radio_row {
      : radio_button {
         label = "Block";
         key = "fblock";
      }
      : radio_button {
         label = "Layer";
         key = "flayer";
      }
      : radio_button {
         label = "Text";
         key = "ftext";
      }
   }
   :edit_box{
      key = "filter";
   }
   ok_cancel;
}

spat : dialog {
   label = "Finder";
   :edit_box{
      label = "File name:  ";
      key = "ff_filename";
      value = "*.DWG";
      width = 55;
   }
   :edit_box{
      label = "Containing: ";
      key = "ff_filter";
      width = 55;
   }
   :row{
      children_alignment = top;
      :column{
         : radio_column {
            fixed_height = true;
            :radio_button {
               label = "Current directory";
               value = "1";
               key = "ff_search0";
            }
            :radio_button {
               label = "Entire drive";
               key = "ff_search1";
            }
            :radio_button {
               label = "All drives";
               key = "ff_search2";
            }
         }
         : button {
            label = "Start";
            key = "ff_accept";
         }
         : button {
            label = "Cancel";
            is_cancel = true;
            key = "ff_cancel";
         }
      }
      :list_box{
         height = 8;
         width = 45;
         fixed_width = true;
         key = "ff_findlist";
      }
   }
   :row{
      :text{
         label = "Current directory:";
      }
      :text{
         key = "ff_curdir";
         width = 45;
      }
   }
   :row{
      :text{
         label = "Status:";
      }
      :text{
         width = 45;
         key = "ff_status";
      }
   }
}

about: dialog {
   :paragraph{
      width = 40;
      :text_part{
         key = "line1";
      }
      :text_part{
         key = "line2";
      }
      :text_part{
         key = "line3";
      }
      :text_part{
         key = "line4";
      }
      :text_part{
         key = "line5";
      }
      :text_part{
         key = "line6";
      }
      :text_part{
         key = "line7";
      }
      :text_part{
         key = "line8";
      }
      :text_part{
         key = "line9";
      }
      :text_part{
         key = "line10";
      }
      :text_part{
         key = "line11";
      }
      :text_part{
         key = "line12";
      }
   }
   cancel_button;
}


sort : dialog {
      label = "Sort by";
   : radio_column {
      fixed_height = true;
      :radio_button {
         label = "Name";
//       value = "1";
         key = "ss_name";
      }
      :radio_button {
         label = "Date";
         key = "ss_date";
      }
      :radio_button {
         label = "Size";
         key = "ss_size";
      }
   }
   ok_cancel;
}

dwgmod : dialog {
   label = "Drawing Modification";
   initial_focus = "save";
   : column {
       : text {
           label = "The current drawing has been changed.";
           alignment = centered;
       }
       : row {
           : button {
               label ="Save Changes...";
               is_default = true;
               mnemonic = "S";
               key = "save";
           }
           : button {
               label = "Discard Changes";
               mnemonic = "D";
               key = "discard";
           }
           : button {
               label = "Cancel Command";
               is_cancel = true;
               mnemonic = "C";
               key = "cancel";
           }
       }
   }
}

