;  FASTCMD.LSP
 ;
 ;                         QUICK COMMAND Release 3.0
 ;                   FASTCMD.LSP is a module of QUICK COMMAND
;                        Copyright 1989, 90, 92 Dan Jincks
 ;
 ;
;              This is SHAREWARE, it is NOT Public Domain software.
 ;
 ;              This code or any part of this code may not be reproduced
 ;              in any publication without prior written permission.
 ;
 ;              Printed copy of this code or any part of this code may not
 ;              be distributed without prior written permission.
 ;
 ;              Printed copy may only be made for reference purposes by
 ;              the end user.
 ;
 ;
 ;                               Dan Jincks
 ;                             Box 155A HCR 77
 ;                           Annapolis, MO 63620
 ;
 ;
 ;
 ;   You are granted a limited license to use FASTCMD.LSP for a 30 day trial
 ;   period.  If you wish to continue using any or all of QUICK COMMAND after
 ;   the trial period, you must become a registered user.  As a registered
 ;   user, you may use QUICK COMMAND on 1 workstation or terminal.
 ;   Additional registrations must be bought for each additional workstation or
 ;   terminal.  To become a registered user, see QC3.DOC
 ;
 ;
 ;   You may send copies of QUICK COMMAND to friends and associates if you abide
 ;   by the following rules:
 ;
 ;   1. It may only be distributed in the original unmodified form.
 ;   2. All original files must be included.
 ;   3. No addition files may be added.
 ;   4. If other files will be on the same disk, QUICK COMMAND files must be in
 ;      a library format such as ".ARC" called "QUICKCMD", or else be put alone
 ;      in a subdirectory called "QUICKCMD".
 ;   5. You may not sell QUICK COMMAND or any part of it.
 ;   6. You are not allowed to charge more then $5 to cover the cost of copying
 ;      and distribution.
 ;   7. You may not distribute any hard copy of the contents of QUICK COMMAND.
 ;
 ;
 ;   These AutoLISP commands and functions are designed to save you time, and
 ;   saving time means saving money.  The registration fee is very modest
 ;   compared to the savings, and much less expensive then typical third party
 ;   AutoCAD software. Be sure to registar if you continue to use them.
 ;
 ;
 ;                                                               DAN
 ;
 ;
 ;
 ;
 ;        AutoCAD and AutoLISP are registered trade marks of Autodesk Inc.
 ;
 ;        ***************************************************************
 ;
 ;  Begin FASTCMD.LSP
 ;
 (setq SCMC 1)
 ;

;  TMC function
(defun C:TMC ()
   (if (= SCMC nil)(setq SCMC 0))
   (setq SCMC (abs (- SCMC 1)))
   (if (= SCMC 0)
      (prompt "Menu calling is OFF.")
      (prompt "Menu calling is ON."))(princ)
)

;  Command Alias Functions with menu calling

;  3DF function
(defun C:3DF()(if(= SCMC 1)(progn(menucmd "S=X")(menucmd "S=3DFACE")))
   (command "3DFACE"))

;  3DM function
(defun C:3DM()(if(= SCMC 1)(progn(menucmd "S=X")(menucmd "S=3D")))
   (command "3DMESH"))

;  3DP function
(defun C:3DP()(if(= SCMC 1)(progn(menucmd "S=X")(menucmd "S=3DPOLY")))
   (command "3DPOLY"))

;  3DS function
(defun C:3DS()(if(= SCMC 1)(progn(menucmd "S=X")(menucmd "S=3D"))))

;  A function
(defun C:A()(if(= SCMC 1)(progn(menucmd "S=X")(menucmd "S=ARC")))
   (command "ARC"))

;  AA function
(defun C:AA()(if(= SCMC 1)(progn(menucmd "S=X")(menucmd "S=AREA")))
   (command "AREA"))

;  AY function
(defun C:AY()(if(= SCMC 1)(progn(menucmd "S=X")(menucmd "S=ARRAY")))
   (command "ARRAY"))

;  B function
(defun C:B()(if(= SCMC 1)(progn(menucmd "S=X")(menucmd "S=BREAK")))
   (command "BREAK"))

;  BL function
(defun C:BL()(if(= SCMC 1)(progn(menucmd "S=X")(menucmd "S=BLOCK")))
   (command "BLOCK"))

;  C function
(defun C:C()(if(= SCMC 1)(progn(menucmd "S=X")(menucmd "S=COPY")))
   (command "COPY"))

;  CH function
(defun C:CH()(if(= SCMC 1)(progn(menucmd "S=X")(menucmd "S=CHANGE")))
   (command "CHANGE"))

;  CF function
(defun C:CF()(if(= SCMC 1)(progn(menucmd "S=X")(menucmd "S=CHAMFER")))
   (command "CHAMFER"))

;  COL function
(defun C:COL()(if(= SCMC 1)(progn(menucmd "S=X")(menucmd "S=COLOR")))
   (command "COLOR"))

;  CP function
(defun C:CP()(if(= SCMC 1)(progn(menucmd "S=X")(menucmd "S=CHPROP")))
   (command "CHPROP"))

;  CR function
(defun C:CR()(if(= SCMC 1)(progn(menucmd "S=X")(menucmd "S=CIRCLE")))
   (command "CIRCLE"))

;  D function
(defun C:D()(command "DIST"))

;  DT function
(defun C:DT()(if(= SCMC 1)(progn(menucmd "S=X")(menucmd "S=DTEXT")))
   (command "DTEXT"))

;  DD function
(defun C:DD()(if(= SCMC 1)(progn(menucmd "S=X")(menucmd "S=DIVIDE")))
   (command "DIVIDE"))

;  DL function
(defun C:DL()(if(= SCMC 1)(progn(menucmd "S=X")(menucmd "S=DIMLINEAR")))
   (command "DIM"))

;  DM function
(defun C:DM()(if(= SCMC 1)(progn(menucmd "S=X")(menucmd "S=DIM")))
   (command "DIM"))

;  DO function
(defun C:DO()(command "DONUT"))

;  DV function
(defun C:DV()(if(= SCMC 1)(progn(menucmd "S=X")(menucmd "S=DVIEW")))
   (command "DVIEW"))

;  E function
(defun C:E()(if(= SCMC 1)(progn(menucmd "S=X")(menucmd "S=ERASE")))
   (command "ERASE"))

;  EDG function
(defun C:EDG()(if(= SCMC 1)(progn(menucmd "S=X")(menucmd "S=3D")))
   (command "EDGESURF"))

;  EE function
(defun C:EE()(if(= SCMC 1)(progn(menucmd "S=X")(menucmd "S=ELLIPSE")))
   (command "ELLIPSE"))

;  EV function
(defun C:EV()(if(= SCMC 1)(progn(menucmd "S=X")(menucmd "S=ELEVTHK")))
   (command "ELEV"))

;  F function
(defun C:F()(if(= SCMC 1)(progn(menucmd "S=X")(menucmd "S=FILLET")))
   (command "FILLET"))

;  G function
(defun C:G()(if(= SCMC 1)(progn(menucmd "S=X")(menucmd "S=GRID")))
   (command "GRID"))

;  H function
(defun C:H()(if(= SCMC 1)(progn(menucmd "S=X")(menucmd "S=HATCH")))
   (command "HATCH"))

;  I function
(defun C:I()(if(= SCMC 1)(progn(menucmd "S=X")(menucmd "S=INSERT")))
   (command "INSERT"))

;  IS function
(defun C:IS()(command "ISOPLANE"))

;  L function
(defun C:L()(if(= SCMC 1)(progn(menucmd "S=X")(menucmd "S=LINE")))
   (command "LINE"))

;  LA function
(defun C:LA()(if(= SCMC 1)(progn(menucmd "S=X")(menucmd "S=LAYER")))
   (command "LAYER"))

;  LI function
(defun C:LI()(if(= SCMC 1)(progn(menucmd "S=X")(menucmd "S=LIST")))
   (command "LIST"))

;  LM function
(defun C:LM()(if(= SCMC 1)(progn(menucmd "S=X")(menucmd "S=LIMITS")))
   (command "LIMITS"))

;  LT function
(defun C:LT()(if(= SCMC 1)(progn(menucmd "S=X")(menucmd "S=LINETYPE")))
   (command "LINETYPE"))

;  LTS function
(defun C:LTS()(command "LTSCALE"))

;  M function
(defun C:M()(if(= SCMC 1)(progn(menucmd "S=X")(menucmd "S=MOVE")))
   (command "MOVE"))

;  ME function
(defun C:ME()(if(= SCMC 1)(progn(menucmd "S=X")(menucmd "S=MEASURE")))
   (command "MEASURE"))

;  MI function
(defun C:MI()(if(= SCMC 1)(progn(menucmd "S=X")(menucmd "S=MINSERT")))
   (command "MINSERT"))

;  MR function
(defun C:MR()(if(= SCMC 1)(progn(menucmd "S=X")(menucmd "S=MIRROR")))
   (command "MIRROR"))

;  MSL function
(defun C:MSL()(command "MSLIDE"))

;  O function
(defun C:O()(if(= SCMC 1)(progn(menucmd "S=X")(menucmd "S=OFFSET")))
   (command "OFFSET"))

;  OS function
(defun C:OS()(if(= SCMC 1)(progn(menucmd "S=X")(menucmd "S=OSNAPC")))
   (command "OSNAP"))

;  P function
(defun C:P()(command "PAN"))

;  PE function
(defun C:PE()(if(= SCMC 1)(progn(menucmd "S=X")(menucmd "S=P0")))
   (command "PEDIT"))

;  PG function
(defun C:PG()(if(= SCMC 1)(progn(menucmd "S=X")(menucmd "S=POLYGON")))
   (command "POLYGON"))

;  PL function
(defun C:PL()(if(= SCMC 1)(progn(menucmd "S=X")(menucmd "S=PLINE")))
   (command "PLINE"))

;  PT function
(defun C:PT()(if(= SCMC 1)(progn(menucmd "S=X")(menucmd "S=POINT")))
   (command "POINT"))

;  QY function
(defun C:QY()(command "QTEXT" "ON"))

;  QN function
(defun C:QN()(command "QTEXT" "OFF"))

;  R function
(defun C:R()(command "REDRAW"))

;  RA function
(defun C:RA()(command "REDRAWALL"))

;  REV function
(defun C:REV()(if(= SCMC 1)(progn(menucmd "S=X")(menucmd "S=3D")))
   (command "REVSURF"))

;  RG function
(defun C:RG()(command "REGEN"))

;  RGA function
(defun C:RGA()(command "REGENALL"))

;  RN function
(defun C:RN()(if(= SCMC 1)(progn(menucmd "S=X")(menucmd "S=RENAME")))
   (command "RENAME"))

;  RT function
(defun C:RT()(if(= SCMC 1)(progn(menucmd "S=X")(menucmd "S=ROTATE")))
   (command "ROTATE"))

;  RUL function
(defun C:RUL()(if(= SCMC 1)(progn(menucmd "S=X")(menucmd "S=3D")))
   (command "RULESURF"))

;  SV function
(defun C:SV()(command "SAVE" ""))

;  S function
(defun C:S()(if(= SCMC 1)(progn(menucmd "S=X")(menucmd "S=SCALE")))
   (command "SCALE"))

;  SCR function
(defun C:SCR()(if(= SCMC 1)(progn(menucmd "S=X")(menucmd "S=SCRIPT")))
   (command "SCRIPT"))

;  SEL function
(defun C:SEL()(if(= SCMC 1)(progn(menucmd "S=X")(menucmd "S=SELECT")))
   (command "SELECT"))

;  SK function
(defun C:SK()(if(= SCMC 1)(progn(menucmd "S=X")(menucmd "S=SKETCH")))
   (command "SKETCH"))

;  SN function
(defun C:SN()(if(= SCMC 1)(progn(menucmd "S=X")(menucmd "S=SNAP")))
   (command "SNAP"))

;  SO function
(defun C:SO()(if(= SCMC 1)(progn(menucmd "S=X")(menucmd "S=SOLID")))
   (command "SOLID"))

;  ST function
(defun C:ST()(if(= SCMC 1)(progn(menucmd "S=X")(menucmd "S=STRETCH")))
   (command "STRETCH" "C"))

;  SY function
(defun C:SY()(if(= SCMC 1)(progn(menucmd "S=X")(menucmd "S=STYLE")))
   (command "STYLE"))

;  T function
(defun C:T()(if(= SCMC 1)(progn(menucmd "S=X")(menucmd "S=TRIM")))
   (command "TRIM"))

;  TAB function
(defun C:TAB()(if(= SCMC 1)(progn(menucmd "S=X")(menucmd "S=3D")))
   (command "TABSURF"))

;  UC function
(defun C:UC()(if(= SCMC 1)(progn(menucmd "S=X")(menucmd "S=UCS1")))
   (command "UCS"))

;  UN function
(defun C:UN()(if(= SCMC 1)(progn(menucmd "S=X")(menucmd "S=UNDO")))
   (command "UNDO"))

;  VI function
(defun C:VI()(if(= SCMC 1)(progn(menucmd "S=X")(menucmd "S=VIEW")))
   (command "VIEW"))

;  VP function
(defun C:VP()(if(= SCMC 1)(progn(menucmd "S=X")(menucmd "S=VPORTS")))
   (command "VPORTS"))

;  VSL function
(defun C:VSL()(command "VSLIDE"))

;  WB function
(defun C:WB()(if(= SCMC 1)(progn(menucmd "S=X")(menucmd "S=WBLOCK")))
   (command "WBLOCK"))

;  X function
(defun C:X()(if(= SCMC 1)(progn(menucmd "S=X")(menucmd "S=EXTEND")))
   (command "EXTEND"))

;  XP function
(defun C:XP()(command "EXPLODE"))

;  Z function
(defun C:Z()(if(= SCMC 1)(progn(menucmd "S=X")(menucmd "S=ZOOM")))
   (command "ZOOM"))


;  Command Short Cut Functions


;  CD function
(defun C:CD() (command "CIRCLE" pause "dia"))

;  EC function  
(defun C:EC() (command "ERASE" "Crossing" ))

;  EL function
(defun C:EL() (command "ERASE" "Last" ""))

;  EW function
(defun C:EW() (command "ERASE" "Window" ))

;  F0 function [F zero]
(defun C:F0() (command "FILLET" "R" "0" "FILLET"))

;  II function
(defun C:II() (command "INSERT" pause pause "" ""))

;  III function
(defun C:III() (command "INSERT" pause pause "" "" ""))

;  PC function
(defun C:PC() (command "PLAN" ""))

;  PU function
(defun C:PU() (command "PLAN" "U"))

;  PW function
(defun C:PW() (command "PLAN" "W"))

;  U3 function
(defun C:U3() (command "UCS" "3"))

;  UE function
(defun C:UE() (command "UCS" "E"))

;  UV function
(defun C:UV() (command "UCS" "V"))

;  UX function
(defun C:UX() (command "UCS" "X"))

;  UY function
(defun C:UY() (command "UCS" "Y"))

;  UZ function
(defun C:UZ() (command "UCS" "Z"))

;  VD function
(defun C:VD() (command "VIEW" "Delete"))

;  VE function
(defun C:VE() (command "VIEW" "R" "E"))

;  VR function
(defun C:VR() (command "VIEW" "Restore"))

;  VS function
(defun C:VS() (command "VIEW" "Save"))

;  VV function
(defun C:VV() (command "VIEW" "?"))

;  V1 function
(defun C:V1() (command "VIEW" "R" "1"))

;  V2 function
(defun C:V2() (command "VIEW" "R" "2"))

;  V3 function
(defun C:V3() (command "VIEW" "R" "3"))

;  V4 function
(defun C:V4() (command "VIEW" "R" "4"))

;  ZE function
(defun C:ZE() (command "ZOOM" "E"))

;  ZP function
(defun C:ZP() (command "ZOOM" "P"))

;  ZW function
(defun C:ZW() (command "ZOOM" "W"))

;  B1 function
(defun C:B1() (prompt " Break at a single point.")(terpri)
              (command "BREAK" pause "F" pause "@0,0"))
 ;
 ;   End FASTCMD.LSP
