@Echo Off
  Echo .
  Echo *===[ MkSlide.Bat copyright 1992 Mountain Software ]===*
  Echo .
  Echo MkSlide.Bat will create a slide file for each AutoCAD drawing in a list
  Echo of Directories. Use this batch file to create the initial set of AutoCAD
  Echo slide files for all of your drawings.
  Echo .
  Echo Example:
  Echo .
  Echo MKSLIDE DWGS BLOCKS
  Echo .
  Echo will create slide files for all drawings in the directories DWGS and BLOCKS
  Echo in addition to those in the current directory. MkSlide has only been tested
  Echo with Release 11 and DOS 3.3/5.0 but will probably work with other versions.
  Echo of DOS and AutoCAD. If AutoCAD needs any drivers or any Environment variables
  Echo SET, then you must do that before running MkSlide. Make sure that all menu 
  Echo files, text styles, blocks, or any other external files are available, 
  Echo otherwise the script will fail.
  Echo .
  Echo Press Ctrl-C to cancel or
  Echo .
  Pause
  Echo Creating MSlide.Scr...
:Loop
  Set _DIR=%1
  If [%_DIR%]==[] SET _DIR=.
  If Exist MkSlide.Scr Del MkSlide.Scr
  For %%f In (%_DIR%\*.dwg) Do Echo 2 %%f .MSLIDE  .QUIT Y>>MkSlide.Scr
  Echo 0>>MkSlide.Scr
  If Not Exist %_DIR%\*.dwg GoTo NoDwgs
  Echo Loading AutoCAD...
  ACAD Dummy MkSlide
:NoDwgs
  If [%_Dir%]==[.] Goto Done
  Shift
  GoTo Loop
:Done
  Echo Done
  Set _DIR=
