echo off
cls
echo.
echo.
echo  Hewlett-Packard Applications Computer Aided Design program (AppCAD) is 
echo  a collection of software tools (or modules) which aid in the design of
echo  RF  and Microwave  circuits  and  systems. AppCAD also includes a part 
echo  selection  guide  for  Hewlett-Packard RF and Microwave semiconductors.
echo.
echo  The following modules are included in the program:
echo.
echo      Transistor Design Data
echo      Mixer Spurious Search
echo      Microwave Calculator
echo      Microwave Path Calculations
echo      Transmission Lines
echo      Two-port Circuit Analysis
echo      Spiral Inductor Design
echo      Impedance Matching
echo      PIN Attenuator and Switch Design
echo      Schottky Detector Calculations
echo      Transistor Bias Circuits
echo      NoiseCalc
echo.
pause
cls
echo.
echo.
echo  Module list continued:
echo.
echo      Thermal Analysis
echo      Product Selection Guide
echo      Literature Request
echo      Sample Request
echo      Register for Updates
echo      For More Information
echo.
echo HARDWARE REQUIREMENTS
echo ---------------------  
echo.
echo AppCAD is designed to work  on all Hewlett-Packard Vectras or IBM PC/XT/AT
echo and compatible computers. A  hard disk MUST be used to install and run the
echo program . MS-DOS(R) versions 2.0 or higher should be used. The recommended
echo minimum  memory  size  is  512 Kbytes. All printed outputs are directed to 
echo parallel  port LPT1.  Printing graphic screens require an Epson compatible
echo printer.
echo.   
echo. 
pause
cls
echo.
echo.
echo COPYING AND DISTRIBUTION
echo ------------------------
echo.
echo  AppCAD may be  copied and distributed freely as long as no fee
echo  is charged. All AppCAD files must be included and not modified.
echo  Hewlett-Packard Co., 1990. All rights reserved.
echo.
echo. 
pause
cls
echo.
echo.
echo INSTALLATION
echo -------------
echo. 
echo  A  hard disk  drive is necessary  to install  and run AppCAD ! 
echo.
echo  AUTOMATIC installation is possible using the INSTALL program :
echo.
echo  Insert Disk 1 into any 5 1/4 drive and type:
echo.     
echo  A:Install  (A drive is for this example, AppCAD can
echo              be  installed  from  any other  drive.)
echo.    
echo  The  program will  ask you what  hard disk  you wish to load AppCAD on.
echo.
echo  For example, if C is your hard disk, type in :  C (no colon is needed). 
echo.
echo  The  program  will  automatically  be installed  onto drive C directory
echo  AppCAD  (install  will create  the directory AppCAD for you).
echo.
echo.
pause
cls
echo.
echo.
echo  MANUAL installation without using the INSTALL program is possible.
echo  The following should be done only if you are experiencing trouble
echo  installing the program using the INSTALL program.  
echo.
echo  1. On your hard disk create a directory AppCAD using the DOS MKDIR 
echo     command . Also, create a sub-directory AppCAD\SPARA. 
echo.
echo  2. Copy from Disk 1 the files README.BAT and PKUNZIP.EXE into the AppCAD
echo     directory using the DOS copy command. From the AppCAD directory type:
echo.
echo     PKUNZIP A:\APPCAD1.ZIP C:\APPCAD
echo.
echo     Wait until PKUNZIP is finished then insert disk 2 into drive A and type:
echo.
echo     PKUNZIP A:\APPCAD2.ZIP C:\APPCAD
echo.  
echo     Wait until PKUNZIP is finished then insert disk 3 into drive A and type:
echo.
echo     PKUNZIP A:\SPARA.ZIP C:\APPCAD\SPARA  after PKUNZIP is finished AppCAD
echo     is installed.
echo.  
echo.
pause
cls
echo.
echo.
echo STARTING THE PROGRAM 
echo ---------------------
echo  Type AppCAD  
echo.
echo  This assumes you are already in the AppCAD directory.
echo.
echo.
echo  Vectra users can run AppCAD from PAM with the following setup:
echo. 
echo  Path:          C:\AppCAD  (Drive C is for this example. Use the drive you
echo                             loaded AppCAD onto.)    
echo.
echo  Applic Title:  AppCAD
echo.
echo  Run Command:   AppCAD
echo.
echo.
pause
cls
echo.
echo.
echo PROGRAM STATUS AND ERROR MESSAGES
echo ---------------------------------- 
echo.
echo  Watch for messages on the bottom of the screen (the 25th text
echo  line). These messages can help guide you through the program
echo  by indicating what data the program expects or which keys are
echo  active. Error messages such as : " Value out of range " may appear
echo  after a calculation. This indicates that a calculated value is
echo  too large to display properly in its designated output field, and
echo  is an error with displaying the number not a calculation error.   
echo.
echo  Memory resident programs such as DOS shells, and pop-up calendars
echo  or spreadsheets may leave too little room for AppCAD to load or
echo  function. An error message "program is too big to fit in memory"
echo  may indicate such a problem . In this case, run AppCAD without
echo  the resident program(s) installed.
echo.
pause
cls
echo.
echo.
echo HELP SCREENS
echo ------------
echo On line help screens are available and should be read before using a 
echo program module. The help screens contain useful information on each
echo of the program modules.
echo.
pause
cls
echo S-Parameters
echo ------------
echo S-parameters for Hewlett-Packard's RF and Microwave transistors and
echo monolithic amplifiers are included with AppCAD. These files are 
echo are in Touchstone text file format and are located in the subdirectory
echo X:\AppCAD\SPARA (X is the drive selected by the user when AppCAD is
echo installed). The s-parameter files can be accessed from both the
echo Transistor Design Data and Two-Port Circuit Analysis modules. Refer
echo to the help screens of these two modules for further details.
echo.
echo The s-parameter files are also located on disk 3 in a non-compressed
echo form . 
echo.
echo Some transistor file names are slightly different than their actual
echo part number. As an example:
echo.
echo XTR3615B.S2P corresponds to HXTR3615 and
echo SMX3131A.S2P corresponds to HSMX3131. 
echo.
echo This was done to conform to DOS's limit of eight characters for the
echo filename. The letter subscripts are used to denote different bias
echo conditions.
echo.
echo.
pause
cls
echo.
echo MS-DOS is a U.S. registered trademark of Microsoft Corporation.
echo.
